"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoadRemoteFileError = exports.JSONParseError = void 0;
var fs = require("fs");
var path = require("path");
var url_1 = require("url");
var events_1 = require("events");
var expression_parser_1 = require("./expression_parser");
var task_scheduler_1 = require("./task_scheduler");
var file_1 = require("../utils/file");
var logger_1 = require("../utils/logger");
var constants_1 = require("../constants");
var types_1 = require("../types");
var file_concentrator_1 = require("./file_concentrator");
var JSONParseError = /** @class */ (function (_super) {
    __extends(JSONParseError, _super);
    function JSONParseError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return JSONParseError;
}(Error));
exports.JSONParseError = JSONParseError;
var LoadRemoteFileError = /** @class */ (function (_super) {
    __extends(LoadRemoteFileError, _super);
    function LoadRemoteFileError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return LoadRemoteFileError;
}(Error));
exports.LoadRemoteFileError = LoadRemoteFileError;
var Downloader = /** @class */ (function (_super) {
    __extends(Downloader, _super);
    function Downloader(_a) {
        var e_1, _b, e_2, _c;
        var threads = _a.threads, retries = _a.retries, headers = _a.headers, output = _a.output, ascending = _a.ascending, concat = _a.concat, timeout = _a.timeout, verbose = _a.verbose, logger = _a.logger;
        var _this = _super.call(this) || this;
        // Config
        _this.threads = 8;
        _this.retries = 5;
        _this.timeout = 30000;
        _this.headers = {};
        _this.output = "./shua_download_" + new Date().valueOf().toString();
        _this.ascending = false;
        _this.concat = false;
        _this.verbose = false;
        // Runtime Status
        /** 当前运行并发数量 */
        _this.nowRunningThreadsCount = 0;
        /** 全部任务数 */
        _this.totalCount = 0;
        /** 已完成任务数 */
        _this.finishCount = 0;
        /** 放弃任务数 */
        _this.dropCount = 0;
        _this.isEnd = false;
        /**
         * 所有需要下载的任务
         * 开始后不修改
         */
        _this.tasks = [];
        _this.taskStatusRecord = [];
        _this.logger = logger || new logger_1.ConsoleLogger();
        if (threads) {
            _this.threads = threads;
        }
        if (retries) {
            _this.retries = retries;
        }
        if (timeout) {
            _this.timeout = timeout;
        }
        _this.headers = {
            "User-Agent": constants_1.DEFAULT_USER_AGENT,
        };
        if (headers) {
            var headerConfigArr = Array.isArray(headers) ? headers : [headers];
            try {
                for (var headerConfigArr_1 = __values(headerConfigArr), headerConfigArr_1_1 = headerConfigArr_1.next(); !headerConfigArr_1_1.done; headerConfigArr_1_1 = headerConfigArr_1.next()) {
                    var headerConfig = headerConfigArr_1_1.value;
                    try {
                        for (var _d = (e_2 = void 0, __values(headerConfig.split("\\n"))), _e = _d.next(); !_e.done; _e = _d.next()) {
                            var h = _e.value;
                            try {
                                var header = /^([^ :]+):(.+)$/.exec(h).slice(1);
                                _this.headers[header[0]] = header[1].trim();
                            }
                            catch (e) {
                                logger.warning("HTTP Headers invalid. Ignored.");
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_e && !_e.done && (_c = _d.return)) _c.call(_d);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (headerConfigArr_1_1 && !headerConfigArr_1_1.done && (_b = headerConfigArr_1.return)) _b.call(headerConfigArr_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
        if (output) {
            if (!fs.existsSync(output)) {
                throw new Error("Output path is not exist.");
            }
            _this.output = output;
        }
        if (ascending) {
            _this.ascending = ascending;
        }
        if (concat) {
            _this.concat = concat;
        }
        if (verbose) {
            _this.verbose = verbose;
            _this.logger.enableDebug();
        }
        _this.setupTaskScheduler();
        return _this;
    }
    Downloader.prototype.onChunkNaming = function (task) {
        if (this.ascending) {
            var ext = (0, file_1.getFileExt)(task.url);
            return task.index.toString().padStart(8, "0") + (ext ? ".".concat(ext) : "");
        }
        var filename = new url_1.URL(task.url).pathname.slice(1);
        var p = filename.split("/");
        return p[p.length - 1];
    };
    /**
     * 从文件添加下载文件 URL
     * @param path 文件路径
     */
    Downloader.prototype.loadUrlsFromFile = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var text, isLoadFromRemote, e_3, tasks, lines, index, url;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        isLoadFromRemote = false;
                        if (!(path.startsWith("http://") || path.startsWith("https://"))) return [3 /*break*/, 5];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        this.logger.debug("Load file from ".concat(path));
                        isLoadFromRemote = true;
                        return [4 /*yield*/, (0, file_1.loadRemoteFile)(path, { headers: this.headers })];
                    case 2:
                        text = _a.sent();
                        this.logger.info("Load file from ".concat(path, " success."));
                        return [3 /*break*/, 4];
                    case 3:
                        e_3 = _a.sent();
                        throw new LoadRemoteFileError("Load remote file failed.");
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        text = fs.readFileSync(path).toString();
                        _a.label = 6;
                    case 6:
                        tasks = [];
                        lines = text
                            .split("\n")
                            .map(function (line) { return line.trim(); })
                            .filter(function (line) { return !!line; });
                        for (index in lines) {
                            url = void 0;
                            if (lines[index].startsWith("#")) {
                                continue;
                            }
                            if (lines[index].startsWith("http://") || lines[index].startsWith("https://")) {
                                url = lines[index];
                            }
                            else if (isLoadFromRemote) {
                                try {
                                    url = new url_1.URL(lines[index], path).href;
                                }
                                catch (e) {
                                    // ignore
                                }
                            }
                            if (url) {
                                tasks.push({ url: url });
                            }
                        }
                        this.addTasks(tasks);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * 从表达式添加任务
     * @param expression 表达式
     */
    Downloader.prototype.loadUrlsFromExpression = function (expression) {
        var expressionParser = new expression_parser_1.default(expression);
        this.addTasks(expressionParser.getUrls().map(function (url) { return ({ url: url }); }));
    };
    /**
     * 从URL数组添加任务
     * @param urls URL数组
     */
    Downloader.prototype.loadUrlsFromArray = function (urls) {
        this.addTasks(urls.map(function (url) { return ({ url: url }); }));
    };
    /**
     * 从 JSON 文件添加任务
     * @param path
     */
    Downloader.prototype.loadUrlsFromJSON = function (path) {
        var text = fs.readFileSync(path).toString();
        var tasks = JSON.parse(text);
        if (!(tasks === null || tasks === void 0 ? void 0 : tasks.length)) {
            throw new JSONParseError("Invalid JSON file.");
        }
        if (tasks.some(function (task) { return !task.url; })) {
            throw new JSONParseError("Missing URL for tasks in JSON file.");
        }
        this.addTasks(tasks);
    };
    Downloader.prototype.setupTaskScheduler = function () {
        var _this = this;
        var scheduler = new task_scheduler_1.default({
            threads: this.threads,
            taskErrorHandler: function (error, task) {
                if (task.retryCount > _this.retries) {
                    return task_scheduler_1.TaskFailDecision.DROP;
                }
                return task_scheduler_1.TaskFailDecision.RETRY;
            },
        });
        scheduler.on("task-finish", function (_a) {
            var task = _a.task, finishCount = _a.finishCount;
            _this.taskStatusRecord[task.payload.index] = types_1.TaskStatus.DONE;
            _this.finishCount++;
            if (_this.concat) {
                _this.fileConcentrator.addTasks([
                    {
                        filePath: path.resolve(_this.output, task.payload.filename),
                        index: task.payload.index,
                    },
                ]);
            }
            _this.logger.info("".concat(_this.finishCount, " / ").concat(_this.totalCount, " or ").concat(((_this.finishCount / _this.totalCount) * 100).toFixed(2), "% finished | ETA: ").concat(_this.getETA()));
            _this.emit("progress", _this.finishCount, _this.totalCount);
        });
        scheduler.on("task-error", function (_a) {
            var task = _a.task, e = _a.error, decision = _a.decision;
            _this.logger.warning("Download ".concat(task.payload.url, " failed, ").concat(decision === task_scheduler_1.TaskFailDecision.DROP ? "max retries exceed, drop." : "retry later.", " [").concat(e.code ||
                (e.response ? "".concat(e.response.status, " ").concat(e.response.statusText) : undefined) ||
                e.message ||
                e.constructor.name ||
                "UNKNOWN", "]"));
            _this.logger.debug(e.request);
            _this.emit("task-error", e, task);
        });
        scheduler.on("task-drop", function (_a) {
            var task = _a.task;
            _this.taskStatusRecord[task.payload.index] = types_1.TaskStatus.DROPPED;
            _this.dropCount++;
        });
        scheduler.once("finish", this.beforeFinish.bind(this));
        this.scheduler = scheduler;
    };
    Downloader.prototype.addTasks = function (tasks) {
        var _this = this;
        this.scheduler.addTasks(tasks.map(function (task, index) { return ({
            handler: _this.handleTask.bind(_this),
            payload: __assign(__assign({}, task), { index: _this.totalCount + index, filename: _this.onChunkNaming({
                    url: task.url,
                    index: _this.totalCount + index,
                }) }),
            retryCount: 0,
            priority: -(_this.totalCount + index), // 默认以添加顺
        }); }));
        for (var index in tasks) {
            var task = tasks[index];
            var taskIndex = this.totalCount + +index;
            var newTask = __assign(__assign({}, task), { index: taskIndex, filename: this.onChunkNaming({
                    url: task.url,
                    index: taskIndex,
                }) });
            this.tasks.push(newTask);
            this.taskStatusRecord[taskIndex] = types_1.TaskStatus.PENDING;
        }
        this.totalCount += tasks.length;
    };
    /**
     * 开始下载
     */
    Downloader.prototype.start = function () {
        if (this.tasks.length === 0) {
            return;
        }
        this.startTime = new Date();
        if (process.platform === "win32") {
            var rl = require("readline").createInterface({
                input: process.stdin,
                output: process.stdout,
            });
            rl.on("SIGINT", function () {
                // @ts-ignore
                process.emit("SIGINT");
            });
        }
        process.on("SIGINT", function () {
            process.exit();
        });
        if (!fs.existsSync(this.output)) {
            fs.mkdirSync(this.output);
        }
        if (this.concat) {
            var ext = (0, file_1.getFileExt)(this.tasks[0].url);
            this.fileConcentrator = new file_concentrator_1.default({
                outputPath: path.resolve(this.output, "_shua_concat_".concat(Date.now()).concat(ext ? ".".concat(ext) : "")),
                taskStatusRecord: this.taskStatusRecord,
                deleteAfterWritten: true,
            });
        }
        this.scheduler.start();
    };
    Downloader.prototype.handleTask = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, file_1.downloadFile)(task.url, path.resolve(this.output, task.filename), __assign(__assign({}, (task.headers
                            ? {
                                headers: __assign(__assign({}, this.headers), task.headers),
                            }
                            : {
                                headers: __assign({}, this.headers),
                            })), { timeout: this.timeout }))];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Downloader.prototype.beforeFinish = function () {
        return __awaiter(this, void 0, void 0, function () {
            var outputPath;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.concat) return [3 /*break*/, 2];
                        outputPath = this.fileConcentrator.getOutputPath();
                        return [4 /*yield*/, this.fileConcentrator.waitAllFilesWritten()];
                    case 1:
                        _a.sent();
                        this.logger.info("All finished. Please checkout your files at [".concat(outputPath, "]"));
                        return [3 /*break*/, 3];
                    case 2:
                        this.logger.info("All finished. Please checkout your files at [".concat(this.output, "]"));
                        _a.label = 3;
                    case 3:
                        if (this.dropCount > 0) {
                            this.logger.warning("".concat(this.dropCount, " files are dropped due to unrecoverable errors."));
                        }
                        this.emit("finish");
                        return [2 /*return*/];
                }
            });
        });
    };
    Downloader.prototype.getETA = function () {
        var usedTime = new Date().valueOf() - this.startTime.valueOf();
        var remainingTimeInSeconds = Math.round(((usedTime / this.finishCount) * this.totalCount - usedTime) / 1000);
        if (remainingTimeInSeconds < 60) {
            return "".concat(remainingTimeInSeconds, "s");
        }
        else if (remainingTimeInSeconds < 3600) {
            return "".concat(Math.floor(remainingTimeInSeconds / 60), "m ").concat(remainingTimeInSeconds % 60, "s");
        }
        else {
            return "".concat(Math.floor(remainingTimeInSeconds / 3600), "h ").concat(Math.floor((remainingTimeInSeconds % 3600) / 60), "m ").concat(remainingTimeInSeconds % 60, "s");
        }
    };
    return Downloader;
}(events_1.EventEmitter));
exports.default = Downloader;
//# sourceMappingURL=downloader.js.map