/// <reference types="node" />
import * as fs from "fs";
import { TaskStatus } from "../types";
interface FileConcentratorParams {
    taskStatusRecord: TaskStatus[];
    outputPath: string;
    deleteAfterWritten: boolean;
}
interface ConcentrationTask {
    filePath: string;
    index: number;
}
declare class FileConcentrator {
    taskStatusRecords: TaskStatus[];
    tasks: ConcentrationTask[];
    outputPath: string;
    writeStream: fs.WriteStream;
    lastFinishIndex: number;
    isCheckingWritableFiles: boolean;
    deleteAfterWritten: boolean;
    constructor({ taskStatusRecord, outputPath, deleteAfterWritten }: FileConcentratorParams);
    private waitStreamWritable;
    private checkWritableTasks;
    private writeFiles;
    addTasks(tasks: ConcentrationTask[]): void;
    waitAllFilesWritten(): Promise<void>;
    getOutputPath(): string;
}
export default FileConcentrator;
