"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var types_1 = require("../types");
var helper_1 = require("../utils/helper");
var FileConcentrator = /** @class */ (function () {
    function FileConcentrator(_a) {
        var taskStatusRecord = _a.taskStatusRecord, outputPath = _a.outputPath, deleteAfterWritten = _a.deleteAfterWritten;
        this.tasks = [];
        this.lastFinishIndex = -1;
        this.isCheckingWritableFiles = false;
        this.deleteAfterWritten = false;
        this.taskStatusRecords = taskStatusRecord;
        this.outputPath = outputPath;
        this.writeStream = fs.createWriteStream(outputPath);
        if (deleteAfterWritten) {
            this.deleteAfterWritten = true;
        }
    }
    FileConcentrator.prototype.waitStreamWritable = function (stream) {
        return new Promise(function (resolve) {
            stream.once("drain", resolve);
        });
    };
    FileConcentrator.prototype.checkWritableTasks = function () {
        return __awaiter(this, void 0, void 0, function () {
            var writableTasks, i, writableTasks_1, writableTasks_1_1, task;
            var e_1, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (this.isCheckingWritableFiles) {
                            return [2 /*return*/];
                        }
                        this.isCheckingWritableFiles = true;
                        writableTasks = [];
                        for (i = this.lastFinishIndex + 1; i <= this.tasks.length; i++) {
                            if (!this.tasks[i] && this.taskStatusRecords[i] === types_1.TaskStatus.DROPPED) {
                                // 文件未下载 但是任务已经被丢弃 忽略空缺
                                continue;
                            }
                            if (!this.tasks[i]) {
                                break;
                            }
                            writableTasks.push(this.tasks[i]);
                        }
                        if (!(writableTasks.length > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.writeFiles(writableTasks)];
                    case 1:
                        _b.sent();
                        if (this.deleteAfterWritten) {
                            try {
                                for (writableTasks_1 = __values(writableTasks), writableTasks_1_1 = writableTasks_1.next(); !writableTasks_1_1.done; writableTasks_1_1 = writableTasks_1.next()) {
                                    task = writableTasks_1_1.value;
                                    fs.unlinkSync(task.filePath);
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (writableTasks_1_1 && !writableTasks_1_1.done && (_a = writableTasks_1.return)) _a.call(writableTasks_1);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                        }
                        _b.label = 2;
                    case 2:
                        this.isCheckingWritableFiles = false;
                        return [2 /*return*/];
                }
            });
        });
    };
    FileConcentrator.prototype.writeFiles = function (tasks) {
        var _this = this;
        this.lastFinishIndex = tasks[tasks.length - 1].index;
        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
            var writable, counter, tasks_1, tasks_1_1, task, e_2_1;
            var e_2, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        writable = true;
                        counter = 0;
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 6, 7, 8]);
                        tasks_1 = __values(tasks), tasks_1_1 = tasks_1.next();
                        _b.label = 2;
                    case 2:
                        if (!!tasks_1_1.done) return [3 /*break*/, 5];
                        task = tasks_1_1.value;
                        writable = this.writeStream.write(fs.readFileSync(task.filePath), function () {
                            counter++;
                            if (counter === tasks.length) {
                                resolve();
                            }
                        });
                        if (!!writable) return [3 /*break*/, 4];
                        // handle back pressure
                        return [4 /*yield*/, this.waitStreamWritable(this.writeStream)];
                    case 3:
                        // handle back pressure
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        tasks_1_1 = tasks_1.next();
                        return [3 /*break*/, 2];
                    case 5: return [3 /*break*/, 8];
                    case 6:
                        e_2_1 = _b.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 8];
                    case 7:
                        try {
                            if (tasks_1_1 && !tasks_1_1.done && (_a = tasks_1.return)) _a.call(tasks_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        }); });
    };
    FileConcentrator.prototype.addTasks = function (tasks) {
        var e_3, _a;
        try {
            for (var tasks_2 = __values(tasks), tasks_2_1 = tasks_2.next(); !tasks_2_1.done; tasks_2_1 = tasks_2.next()) {
                var task = tasks_2_1.value;
                this.tasks[task.index] = task;
            }
        }
        catch (e_3_1) { e_3 = { error: e_3_1 }; }
        finally {
            try {
                if (tasks_2_1 && !tasks_2_1.done && (_a = tasks_2.return)) _a.call(tasks_2);
            }
            finally { if (e_3) throw e_3.error; }
        }
        this.checkWritableTasks();
    };
    FileConcentrator.prototype.waitAllFilesWritten = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.isCheckingWritableFiles) return [3 /*break*/, 3];
                        _a.label = 1;
                    case 1:
                        if (!this.isCheckingWritableFiles) return [3 /*break*/, 3];
                        return [4 /*yield*/, (0, helper_1.sleep)(200)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3: return [4 /*yield*/, this.checkWritableTasks()];
                    case 4:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FileConcentrator.prototype.getOutputPath = function () {
        return this.outputPath;
    };
    return FileConcentrator;
}());
exports.default = FileConcentrator;
//# sourceMappingURL=file_concentrator.js.map