"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskFailDecision = void 0;
var crypto = require("crypto");
var events_1 = require("events");
var priority_queue_1 = require("../utils/priority_queue");
/** 任务失败决策 */
var TaskFailDecision;
(function (TaskFailDecision) {
    /** 重试 */
    TaskFailDecision[TaskFailDecision["RETRY"] = 0] = "RETRY";
    /** 放弃 */
    TaskFailDecision[TaskFailDecision["DROP"] = 1] = "DROP";
    /** 提升优先级并重试 */
    TaskFailDecision[TaskFailDecision["INCREASE_PRIORITY"] = 2] = "INCREASE_PRIORITY";
})(TaskFailDecision = exports.TaskFailDecision || (exports.TaskFailDecision = {}));
var TaskScheduler = /** @class */ (function (_super) {
    __extends(TaskScheduler, _super);
    function TaskScheduler(options) {
        var _this = _super.call(this) || this;
        _this.nowRunningThreadsCount = 0;
        _this.isFinished = false;
        _this.finishCount = 0;
        _this.dropCount = 0;
        _this.totalCount = 0;
        _this.taskErrorHandler = function () { return TaskFailDecision.RETRY; };
        _this.threads = options.threads;
        _this.queue = new priority_queue_1.default();
        if (options.taskErrorHandler) {
            _this.taskErrorHandler = options.taskErrorHandler;
        }
        return _this;
    }
    Object.defineProperty(TaskScheduler.prototype, "isQueueEmpty", {
        get: function () {
            return this.queue.size === 0;
        },
        enumerable: false,
        configurable: true
    });
    TaskScheduler.prototype.checkQueue = function () {
        return __awaiter(this, void 0, void 0, function () {
            var currentTask;
            var _this = this;
            return __generator(this, function (_a) {
                if (this.isFinished) {
                    return [2 /*return*/];
                }
                currentTask = this.getNextTask();
                if (!currentTask) {
                    if (this.nowRunningThreadsCount === 0) {
                        this.isFinished = true;
                        this.emit("finish");
                    }
                    else {
                        setTimeout(function () {
                            _this.checkQueue();
                        }, 200);
                    }
                }
                else {
                    this.nowRunningThreadsCount++;
                    this.runTask(currentTask)
                        .then(function () {
                        _this.finishCount++;
                        _this.emit("task-finish", {
                            task: currentTask,
                            finishCount: _this.finishCount,
                            dropCount: _this.dropCount,
                            totalCount: _this.totalCount,
                        });
                    })
                        .catch(function (e) {
                        if (e instanceof Error) {
                            var decision = _this.taskErrorHandler(e, currentTask);
                            _this.emit("task-error", { task: currentTask, error: e, decision: decision });
                            switch (decision) {
                                case TaskFailDecision.DROP: {
                                    _this.dropCount++;
                                    _this.emit("task-drop", {
                                        task: currentTask,
                                        error: e,
                                        finishCount: _this.finishCount,
                                        dropCount: _this.dropCount,
                                        totalCount: _this.totalCount,
                                    });
                                    break;
                                }
                                case TaskFailDecision.INCREASE_PRIORITY: {
                                    currentTask.priority++;
                                    currentTask.retryCount++;
                                    _this.addTasks(currentTask);
                                    break;
                                }
                                default: {
                                    currentTask.retryCount++;
                                    _this.addTasks(currentTask);
                                }
                            }
                        }
                    })
                        .finally(function () {
                        _this.nowRunningThreadsCount--;
                        _this.checkQueue();
                    });
                    this.checkQueue();
                }
                return [2 /*return*/];
            });
        });
    };
    TaskScheduler.prototype.getNextTask = function () {
        if (this.isFinished) {
            return;
        }
        if (this.nowRunningThreadsCount > this.threads) {
            return;
        }
        if (this.isQueueEmpty) {
            return;
        }
        return this.queue.getMaxPriorityItem();
    };
    TaskScheduler.prototype.runTask = function (task) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, task.handler(task.payload)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    TaskScheduler.prototype.addTasks = function (tasks) {
        if (Array.isArray(tasks)) {
            this.queue.insertMulti(tasks.map(function (task) { return (__assign({ uuid: crypto.randomUUID(), retryCount: 0, priority: 1 }, task)); }));
            this.totalCount += tasks.length;
        }
        else {
            this.queue.insert(__assign({ uuid: crypto.randomUUID(), retryCount: 0, priority: 1 }, tasks));
            this.totalCount += 1;
        }
    };
    TaskScheduler.prototype.start = function () {
        this.checkQueue();
    };
    TaskScheduler.prototype.waitAllFinished = function () {
        var _this = this;
        if (this.nowRunningThreadsCount === 0 && this.isQueueEmpty) {
            return Promise.resolve();
        }
        return new Promise(function (resolve) {
            _this.once("finished", resolve);
        });
    };
    return TaskScheduler;
}(events_1.EventEmitter));
exports.default = TaskScheduler;
//# sourceMappingURL=task_scheduler.js.map